#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include <sys/poll.h>
#include <fcntl.h>
#include <stdarg.h>

#define BUFSIZE         256
#define MAX_HEADERS     80
#define MAX_LEN         256

#define SRC_PROXY		0
#define SRC_ASTERISK		1
#define SRC_CLIENT		2

struct proxyconfig {
    char ast_addr[INET_ADDRSTRLEN];
    int ast_port;
    char ast_user[80];
    char ast_pass[80];
    char listen_addr[INET_ADDRSTRLEN];
    int listen_port;
    int outputformat;
    int autofilter;
    int events;
    char key[80];
    char proc_user[30];
    char proc_group[30];
    char logfile[80];
};

struct mansession {
    pthread_t t;
    pthread_mutex_t lock;
    struct sockaddr_in sin;
    int fd;
    char inbuf[MAX_LEN];
    int inlen;
    int inputformat;
    int outputformat;
    int autofilter;
    int authenticated;
    char actionid[MAX_LEN];
    struct mansession *next;
};

struct message {
    int hdrcount;
    char headers[MAX_HEADERS][MAX_LEN];
    int source;
};

struct proxyconfig pc;

void debugmsg (const char *, ...);
extern int debug;
