#include "astmanproxy.h"

#define XML_UNPARSED    	"UnparsedText"
#define SRC_PROXYXMLTAG         "AsteriskManagerProxyOutput"
#define SRC_ASTERISKXMLTAG      "AsteriskManagerOutput"


/* Takes a single manager header line and converts xml entities */
void xml_quote_string(char *s, char *o) {

    char *c;
    c = s;

    do {
       if (*c == '<')
            strcat(o, "&lt;");
       else if (*c == '>')
            strcat(o, "&gt;");
       else if (*c == '&')
            strcat(o, "&amp;");
       else if (*c == '"')
            strcat(o, "&quot;");
       else if (*c == '\n')
            strcat(o, " ");
       else
            strncat(o, c, 1);
    } while (*(c++));

    return;
}

int WriteXMLClient(struct mansession *s, struct message *m) {
    int i;
    char buf[BUFSIZE], outstring[MAX_LEN*3], xmlescaped[MAX_LEN*3];
    char *dpos, *lpos, *xmltag;

    if (m->source == SRC_PROXY)
        xmltag = SRC_PROXYXMLTAG;
    else if (m->source == SRC_ASTERISK)
       xmltag = SRC_ASTERISKXMLTAG;
    else
       xmltag = SRC_PROXYXMLTAG;
    sprintf(buf, "<%s>\r\n", xmltag);
    pthread_mutex_lock(&s->lock);
    write(s->fd, buf, strlen(buf));
    pthread_mutex_unlock(&s->lock);
    for (i=0; i<m->hdrcount; i++) {
        memset(xmlescaped, 0, sizeof xmlescaped);
        xml_quote_string(m->headers[i], xmlescaped);
        lpos = xmlescaped;
        dpos = strstr(lpos, ": ");
        if (dpos) {
            strcpy(outstring, " <");
            strncat(outstring, lpos, dpos-lpos);
            strcat(outstring, " Value=\"");
            strncat(outstring, dpos+2, strlen(dpos)-2);
            strcat(outstring, "\"/>\r\n");
        } else
            sprintf(outstring, " <%s Value=\"%s\"/>\r\n", XML_UNPARSED, lpos);
        pthread_mutex_lock(&s->lock);
        write(s->fd, outstring, strlen(outstring) );
        pthread_mutex_unlock(&s->lock);
    }
    sprintf(buf, "</%s>\r\n\r\n", xmltag);
    pthread_mutex_lock(&s->lock);
    write(s->fd, buf, strlen(buf));
    pthread_mutex_unlock(&s->lock);

    return 0;
}

